Recent

Author Topic: New Version of FPCUPdeluxe specially for embedded targets  (Read 3005 times)

MiR

  • Full Member
  • ***
  • Posts: 206
New Version of FPCUPdeluxe specially for embedded targets
« on: February 28, 2021, 09:44:08 pm »
Don Alfredo has released a new version of FPCUPdeluxe this weekend, the most important feature of this new release is the simplification of Installations for embedded targets.

Many thanks to Don Alfredo, he has spent the last weekends on optimizing FPCUPdeluxe to make it work A LOT better for embedded.

The new Version makes it very easy to build and use crosscompilers for arm-embedded, avr-embedded xtensa-freertos and arm-freertos.

Give it a try, you will not regret it!

Michael

Install from here:

https://github.com/LongDirtyAnimAlf/fpcupdeluxe/releases

My updated doku on the Wiki:

https://wiki.freepascal.org/ARM_Embedded_Tutorial_-_Installing_Lazarus_and_Free_Pascal






y.ivanov

  • Sr. Member
  • ****
  • Posts: 306
Re: New Version of FPCUPdeluxe specially for embedded targets
« Reply #1 on: April 15, 2021, 02:58:43 pm »
Install from here:

https://github.com/LongDirtyAnimAlf/fpcupdeluxe/releases

My updated doku on the Wiki:

https://wiki.freepascal.org/ARM_Embedded_Tutorial_-_Installing_Lazarus_and_Free_Pascal

Hi MiR,
I was curious about the FPCUPdeluxe for embedded targets, namely for STM32F0.
My machine is Ubuntu 18.04.5 LTS. I've downloaded fpcupdeluxe-x86_64-linux, V1.8.2r for x86_64-linux-gtk2. On the 'Basic' tab there is no 'embedded-mir' for FPC and 'embedded' for Lazarus. Using 'trunk.git' for both gives me an errors (when building Lazarus, I believe):

Code: [Select]
[snip]
(3104) Compiling ./frames/editor_dividerdraw_options.pas
(3104) Compiling ./frames/editor_multiwindow_options.pas
(3104) Compiling ./frames/editor_indent_options.pas
(3104) Compiling ./frames/codetools_general_options.pas
(3104) Compiling ./frames/codetools_codecreation_options.pas
(3104) Compiling ./frames/codetools_classcompletion_options.pas
(3104) Compiling ./frames/codetools_wordpolicy_options.pas
(3104) Compiling ./frames/codetools_linesplitting_options.pas
(3104) Compiling ./frames/atom_checkboxes_options.pas
(3104) Compiling ./frames/codetools_space_options.pas
(3104) Compiling ./frames/codetools_identifiercompletion_options.pas
(3104) Compiling /home/alpi/fpcupdeluxe-arm/fpcupdeluxe-arm/lazarus/debugger/frames/debugger_general_options.pas
(3104) Compiling patheditordlg.pas
(3104) Compiling genericlistselect.pas
(3104) Compiling /home/alpi/fpcupdeluxe-arm/fpcupdeluxe-arm/lazarus/debugger/frames/debugger_class_options.pas
/home/alpi/fpcupdeluxe-arm/fpcupdeluxe-arm/lazarus/debugger/frames/debugger_class_options.pas(647,27) Error: (5000) Identifier not found "lisDebugOptionsFrmEditClass"
/home/alpi/fpcupdeluxe-arm/fpcupdeluxe-arm/lazarus/debugger/frames/debugger_class_options.pas(648,33) Error: (5000) Identifier not found "lisDebugOptionsFrmEditClassWarn"
debugger_class_options.pas(717) Fatal: (10026) There were 2 errors compiling module, stopping
Fatal: (1018) Compilation aborted
make[2]: *** [idepkg] Error 2
make[1]: *** [idepkg] Error 2
Error: /home/alpi/fpcupdeluxe-arm/fpcupdeluxe-arm/fpc/bin/x86_64-linux/ppcx64 returned an error exitcode
Makefile:4667: recipe for target 'lazarus' failed
Makefile:5105: recipe for target 'idepkg' failed
Makefile:3685: recipe for target 'idepkg' failed
Error: (lazarus) Build IDE: stopped with exit code 2
make: *** [useride] Error 2
Error: (lazarus) Building IDE: Building IDE failed.
Makefile:3691: recipe for target 'useride' failed
fpcupdeluxe: ERROR: LazarusNativeInstaller (BuildModuleCustom: UserIDE): make returned exit status #512


ERROR: Fpcupdeluxe fatal error !
Sequencer (UserIDE): Failure running fpcupdeluxe: error executing sequence UserIDE
Sequencer (Lazarus): Failure running fpcupdeluxe: error executing sequence Lazarus
Sequencer (Only): Failure running fpcupdeluxe: error executing sequence Only

How to proceed?

Regards,

MiR

  • Full Member
  • ***
  • Posts: 206
Re: New Version of FPCUPdeluxe specially for embedded targets
« Reply #2 on: April 15, 2021, 03:20:56 pm »
I will have to update the documentation, in latest fpcupdeluxe embedded-mir was renamed to embedded and lazarus trunk now has all the needed changes that are necessary and embedded for lazarus was removed by Don Alfredo...

Choosing embedded for fpc and trunk for lazarus should do the trick.

The error you see is likely unrelated to your choices, I think I today read somewhere else that lazarus trunk itself has build issues atm, seems I was lucky when tesing latest fpcupdeluxe release on my Mac yesterday, then all still worked fine.
« Last Edit: April 15, 2021, 03:24:35 pm by MiR »

y.ivanov

  • Sr. Member
  • ****
  • Posts: 306
Re: New Version of FPCUPdeluxe specially for embedded targets
« Reply #3 on: April 15, 2021, 03:50:51 pm »
Thanks MiR,

Probably I'll wait until issues resolved. Not in a hurry.

I'm developing embedded products for a long time and, as you can easily guess, I use C language for that + a lot of different toolchains and IDEs.
 
Your post greatly increased my interest in cross-FPC, especially since I saw AVR and Z80 in the list, which are very small processors. I wonder how it is possible to develop for them, and since the information is quite scarce, how can I get more information about? This child board?

Regards,

EDIT: Sorry, I've just found https://forum.lazarus.freepascal.org/index.php/topic,49536.msg359394.html#msg359394. I'll read this board first before asking more silly questions.
« Last Edit: April 15, 2021, 03:58:50 pm by y.ivanov »

MiR

  • Full Member
  • ***
  • Posts: 206
Re: New Version of FPCUPdeluxe specially for embedded targets
« Reply #4 on: April 15, 2021, 04:01:35 pm »
Use the wiki as a starting point, there are a number of articles for avr + arm:

https://wiki.freepascal.org/Portal:Embedded

and when you still have questions use this board and it's subboards to get help. 


coradi

  • Full Member
  • ***
  • Posts: 105
Re: New Version of FPCUPdeluxe specially for embedded targets
« Reply #6 on: October 17, 2021, 08:41:30 pm »
Hi,
I got this error Message:-( As I tried to install ARM Support

fpcupdeluxe: Start of compile error summary.
fpcupdeluxe: ERROR: FPCCrossInstaller (BuildModule: FPC): C:\fpcupdeluxe\fpcsrc\Makefile not found. Severe error. Should not happen. Aborting.
fpcupdeluxe: Done !!
Amstrad Schneider CPC 6128
Wind XP / 7 / 10

 

TinyPortal © 2005-2018